#include "programInfo.hh"

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
#include <iostream>
using namespace std;

int programInfo::test()
{
  // Modified from example code at http://www.devx.com/Intel/Article/15914/0/page/2

  pid_t cpid;
  int status;

  // cout << "Parent process" << endl;
  switch (cpid = fork())
  {
    case -1: perror("fork failed");
             exit(1);

    case  0: 
             // cout << "Child process" << endl;
             execv(programFilename, args);
             perror("execl failed");
             exit(1); // note: this only makes the CHILD process exit :(

    default: 
             // cout << "Still in parent process" << endl;
             if (waitpid(cpid, &status, 0) == -1)
             {
               perror("wait interrupted");
               exit(1);
             }

             if (WIFEXITED(status)) 
             {
               // cout << "Child process completed. Status is " << WEXITSTATUS(status) << endl;

               return WEXITSTATUS(status);
             }
             else
             {
               perror("wait failed");
               exit(1);
             }
  }

  return 0;
}
